#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: ihm_rex.tcl,v 1.43 2004/12/06 08:48:47 mcourtoi Exp $

# choix d'un item du menu rex
#################################################################
proc choix_rex { ssongl } {
   global rex_liste
   switch -exact -- $ssongl {
      rex { }
      ident {
         # choix du correspondant
         rex_corresp
      }
      emis_sans {
         # emission d'une fiche sans prendre en compte le profil
         if { [rex_verif_identite] && [rex_verif_corresp] } {
            rex_saisie_fiche 0
         }
      }
      emis_prof {
         # emission d'une fiche avec export du profil et rcupration des fichiers
         if { [rex_verif_identite] && [rex_verif_corresp] } {
            rex_saisie_fiche 1
         }
      }
      consult {
         # consultation des fiches
         set test -1
         catch { set test [llength $rex_liste] }
         if { $test == -1 } {
            # initialise les critres
            set astk::rex(filt,type) "AL"
            set astk::rex(filt,an) [clock format [clock seconds] -format "%Y"]
         }
         rex_consult
      }
      consult_a_corriger {
         # consultation des fiches
         set rex_liste [list]
         rex_ini_filtres
         set astk::rex(filt,etat) "ENREGISTRE"
         set astk::rex(filt,correct_nom) [agla_cua_get $astk::config(-1,cua) 0]
         set astk::rex(filt,correct_dpt) $astk::config(-1,org)
         rex_consult "correct"
      }
      consult_supprimer {
         # supprimer des fiches
         set rex_liste [list]
         rex_ini_filtres
         set astk::rex(filt,etat) "EMIS_*"
         rex_consult "suppr"
      }
      default {
         ashare::mess erreur 5 $ssongl
      }
   }
}

# choix d'un correspondant
#################################################################
proc rex_corresp { } {
   global select_corresp
   set fen .fen_rex_corresp
   catch {destroy $fen}
   toplevel $fen
   wm withdraw $fen
   wm title $fen "[ashare::mess ihm 209]"
   wm transient $fen .
   grab set $fen

   # liste des correspondants
   set select_corresp -1
   set liste $astk::agla(list_cua)
   set nb [expr [llength $liste] / 4]
   if { $nb > 0 } {
      # pour fixer la largeur
      pack [label $fen.bidon -width 60 -text ""] -fill x
      # liste
      set MenuCor [tk_optionMenu $fen.liste bid_corresp [ashare::mess ihm 214]]
      $MenuCor entryconfigure 0 -font $astk::ihm(font,labmenu) -command "set select_corresp -1"
      for {set j 0} {$j < $nb} {incr j} {
         set lab [lindex $liste [expr $j*4]]
         append lab " / "
         append lab [lindex $liste [expr $j*4 + 3]]
         $MenuCor add radiobutton
         $MenuCor entryconfigure [expr $j+1] -label $lab -font $astk::ihm(font,labmenu) -variable bid_corresp -command "set select_corresp $j"
      }
      pack $fen.liste -fill x -padx 15 -pady 10 -expand yes
   }
   # ok / annuler
   pack [frame $fen.valid -relief solid -bd 0] -pady 15
      button $fen.valid.annuler -font $astk::ihm(font,labbout) -text [ashare::mess ihm 85] \
         -background $astk::ihm(couleur,annul) \
         -command "destroy $fen ; grab release $fen"
      button $fen.valid.ok -font $astk::ihm(font,labbout) -text "Ok" \
         -background $astk::ihm(couleur,valid) \
         -command "accept_corresp ; destroy $fen ; grab release $fen"
      pack $fen.valid.ok $fen.valid.annuler -side left -padx 10 -pady 5
   
   wm deiconify $fen
}

# validation du correspondant
#################################################################
proc accept_corresp { } {
   global select_corresp
   if { $select_corresp > -1 } {
      set astk::config(-1,cua) [lindex $astk::agla(list_cua) [expr $select_corresp*4 + 1]]
   } else {
      set astk::config(-1,cua) ""
   }
   ashare::save_prefs
}

# verifie que l'identit a t renseigne
# retourne 1 si ok, 0 sinon
#################################################################
proc rex_verif_identite { } {
   if { $astk::config(-1,nom_user) == "" || [regexp {Firstname} $astk::config(-1,nom_user)]
     || $astk::config(-1,email) == "" || $astk::config(-1,email) == "address@mail.com" } {
      tk_messageBox -message [ashare::mess ihm 248] -type ok -icon info
      return 0
   }
   return 1
}

# verif correspondant, demande de choisir si vide
# retourne 1 si ok, 0 sinon
#################################################################
proc rex_verif_corresp { } {
   global select_corresp
   if { $astk::agla(num_serv) == -1 } {
      set astk::config(-1,cua) "ASTER_LIBRE"
   } elseif { $astk::config(-1,cua) == "" || $astk::config(-1,cua) == "ASTER_LIBRE" || [regexp "Non_d.fini" $astk::config(-1,cua)] } {
   # choix
      rex_corresp
      tkwait window .fen_rex_corresp
      if { $astk::config(-1,cua) == "" } {
         return 0
      }
   }
   return 1
}

# saisie d'une fiche (fich_asso=1 si fichiers associs,  0 sinon)
#################################################################
proc rex_saisie_fiche { fich_asso } {
   global rex_ftype rex_fcmde bid_typfic
   set fen .fen_rex_fiche
   catch {destroy $fen}
   toplevel $fen
   wm withdraw $fen
   wm title $fen "[ashare::mess ihm 11]"
   wm transient $fen .

   # fiche
   pack [frame $fen.f -relief flat -bd 0] -fill x -padx 5 -pady 5
   # entete
   label $fen.f.em -font $astk::ihm(font,labbout) -text [ashare::mess ihm 216] -anchor w
   pack $fen.f.em -fill x -expand yes
   
   pack [frame $fen.f.f1a -relief flat -bd 0] -anchor w -padx 5
   label $fen.f.f1a.lab -font $astk::ihm(font,lab) -text "[ashare::mess ihm 89]*" -width 30 -anchor w
   label $fen.f.f1a.val -font $astk::ihm(font,lab) -text $astk::config(-1,nom_user)
   pack $fen.f.f1a.lab $fen.f.f1a.val -side left -padx 10

   pack [frame $fen.f.f1b -relief flat -bd 0] -anchor w -padx 5
   label $fen.f.f1b.lab -font $astk::ihm(font,lab) -text "[ashare::mess ihm 90]*" -width 30 -anchor w
   label $fen.f.f1b.val -font $astk::ihm(font,lab) -text $astk::config(-1,email)
   pack $fen.f.f1b.lab $fen.f.f1b.val -side left -padx 10

   if { $astk::config(-1,org) == "" } {
      set astk::config(-1,org) [ashare::mess ihm 239]
   }
   pack [frame $fen.f.f1f -relief flat -bd 0] -anchor w -padx 5
   label $fen.f.f1f.lab -font $astk::ihm(font,lab) -text "[ashare::mess ihm 240]*" -width 30 -anchor w
   label $fen.f.f1f.val -font $astk::ihm(font,lab) -text $astk::config(-1,org)
   pack $fen.f.f1f.lab $fen.f.f1f.val -side left -padx 10

   label $fen.f.mod -font $astk::ihm(font,labpt) -text "(*) [ashare::mess ihm 235]"
   pack $fen.f.mod -anchor w -padx 45

   if { $astk::agla(num_serv) != -1 } {
      pack [frame $fen.f.f1g -relief flat -bd 0] -anchor w -padx 5
      label $fen.f.f1g.lab -font $astk::ihm(font,lab) -text [ashare::mess ihm 213] -width 30 -anchor w
      label $fen.f.f1g.val -font $astk::ihm(font,lab) -text "[agla_cua_get $astk::config(-1,cua) 0] ([agla_cua_get $astk::config(-1,cua) 2])"
      pack $fen.f.f1g.lab $fen.f.f1g.val -side left -padx 10
   }

   # paramtres
   label $fen.f.pa -font $astk::ihm(font,labbout) -text [ashare::mess ihm 221] -anchor w
   pack $fen.f.pa -fill x -expand yes
   
   pack [frame $fen.f.f1c -relief flat -bd 0] -anchor w -padx 5
   # type de fiche
   label $fen.f.f1c.lab -font $astk::ihm(font,lab) -text [ashare::mess ihm 217] -width 30 -anchor w
   set ltyp {218 219 236 237 220 238}
   set labb {AL EL AO EO AOM ED}
   set nb [llength $ltyp]
   set rex_ftype ""
   set lab [ashare::mess ihm 227]
   set bid_typfic $lab
   set MenuCor [tk_optionMenu $fen.f.f1c.val bid_typfic $lab]
   $MenuCor entryconfigure 0 -font $astk::ihm(font,labmenu) -command {set rex_ftype ""}
   for {set j 0} {$j < $nb} {incr j} {
      set lab [ashare::mess ihm [lindex $ltyp $j]]
      $MenuCor add radiobutton
      $MenuCor entryconfigure [expr $j+1] -label $lab -font $astk::ihm(font,labmenu) -variable bid_typfic -command "set rex_ftype [lindex $labb $j]"
   }
   pack $fen.f.f1c.lab $fen.f.f1c.val -side left -padx 10 -pady 1

   set rex_fcmde ""
   pack [frame $fen.f.f1d -relief flat -bd 0] -anchor w -padx 5
   label $fen.f.f1d.lab -font $astk::ihm(font,lab) -text [ashare::mess ihm 222] -width 30 -anchor w
   entry $fen.f.f1d.val -font $astk::ihm(font,lab) -textvariable rex_fcmde -width 55
   pack $fen.f.f1d.lab $fen.f.f1d.val -side left -padx 10 -pady 1

   pack [frame $fen.f.f1h -relief flat -bd 0] -anchor w -padx 5
   label $fen.f.f1h.lab -font $astk::ihm(font,lab) -text [ashare::mess ihm 46] -width 30 -anchor w
   label $fen.f.f1h.val -font $astk::ihm(font,lab) -text $astk::profil(version)
   pack $fen.f.f1h.lab $fen.f.f1h.val -side left -padx 10 -pady 1

   # fichiers associs
   pack [frame $fen.f.f1e -relief flat -bd 0] -anchor w -padx 5
   if { $fich_asso } {
      append val [ashare::mess ihm 224]
   } else {
      append val [ashare::mess ihm 225]
   }
   label $fen.f.f1e.lab -font $astk::ihm(font,lab) -text [ashare::mess ihm 223] -width 30 -anchor w
   label $fen.f.f1e.val -font $astk::ihm(font,lab) -text $val
   pack $fen.f.f1e.lab $fen.f.f1e.val -side left -padx 10 -pady 1

   # texte
   pack [frame $fen.f2 -relief flat -bd 0] -fill both -expand yes -padx 5 -pady 5

   text $fen.f2.tx -xscrollcommand "$fen.f2.scrollx set" -yscrollcommand "$fen.f2.scrolly set" \
   -height 20 -width 80 -font $astk::ihm(font,zonfix) -bg $astk::ihm(couleur,entry_background) -wrap word
   scrollbar $fen.f2.scrolly -command "$fen.f2.tx yview"
   scrollbar $fen.f2.scrollx -command "$fen.f2.tx xview" -orient h
   pack $fen.f2.scrolly -side right  -fill y
   pack $fen.f2.scrollx -side bottom -fill x
   pack $fen.f2.tx -expand 1 -fill both

   # ok / annuler
   pack [frame $fen.valid -relief solid -bd 0] -pady 15
      button $fen.valid.annuler -font $astk::ihm(font,labbout) -text [ashare::mess ihm 85] \
         -command "destroy $fen" -bg $astk::ihm(couleur,annul)
      button $fen.valid.ok -font $astk::ihm(font,labbout) -text [ashare::mess ihm 215] \
         -command "rex_envoi $fen $fich_asso" -bg $astk::ihm(couleur,valid)
      pack $fen.valid.ok $fen.valid.annuler -side left -padx 10 -pady 5
   
   wm deiconify $fen
}

# envoi de la fiche
#  parent : fenetre parent
#  fich_asso=1 si fichiers associs, 0 sinon
#################################################################
proc rex_envoi { parent fich_asso } {
   global rex_ftype rex_fcmde
   # phase de vrification
   if { $rex_ftype == "" } {
      set msg [ashare::mess ihm 228]
      change_status $msg
      tk_messageBox -message $msg -type ok -icon info -parent $parent
      return
   }

   # fichiers associs
   if { $fich_asso } {
      set fexp [file join $astk::tmpdir .file_rex_export]
      set astk::profil(special) ""
      set iret [exporter astk_serv -1 $fexp "verif" "oui"]
      if { $iret != 0 } {
         set msg [ashare::mess erreur 40]
         change_status $msg
         tk_messageBox -message $msg -type ok -icon info -parent $parent
         return
      }
   }

# tant que l'on utilise l'AREX "asterix"
   if { $rex_ftype == "AOM" } {
      set rex_ftype "EL"
      set rex_fcmde "AOM : $rex_fcmde"
   }

   set frex [file join $astk::tmpdir .file_rex_fiche]
   set idrex [open $frex w]
   puts $idrex "@NOMUSER@"
   regsub -all " " $astk::config(-1,nom_user) "\." tmp
   puts $idrex $tmp
   puts $idrex "@FINNOMUSER@"
   puts $idrex "@MAILUSER@"
   puts $idrex "$astk::config(-1,email)"
   puts $idrex "@FINMAILUSER@"
   puts $idrex "@UNIUSER@"
   regsub -all " " $astk::config(-1,org) "\." tmp
   puts $idrex $tmp
   puts $idrex "@FINUNIUSER@"
   puts $idrex "@NOMCUA@"
   puts $idrex "[agla_cua_get $astk::config(-1,cua) 0]"
   puts $idrex "@FINNOMCUA@"
   puts $idrex "@MAILCUA@"
   puts $idrex "[agla_cua_get $astk::config(-1,cua) 2]"
   puts $idrex "@FINMAILCUA@"
   puts $idrex "@UNICUA@"
   puts $idrex "[agla_cua_get $astk::config(-1,cua) 3]"
   puts $idrex "@FINUNICUA@"
   puts $idrex "@TITRE@"
   puts $idrex "$rex_fcmde"
   puts $idrex "@FINTITRE@"
   puts $idrex "@DATE1@"
   puts $idrex [clock format [clock seconds] -format "%d/%m/%Y"]
   puts $idrex "@FINDATE1@"
   puts $idrex "@DATE2@"
   if { [regexp {EDA|CUA} $astk::agla(instance)] } {
      puts $idrex [clock format [clock seconds] -format "%d/%m/%Y"]
   }
   puts $idrex "@FINDATE2@"
   puts $idrex "@VERSION@"
   puts $idrex "$astk::profil(version)"
   puts $idrex "@FINVERSION@"
   puts $idrex "@TYPFIC@"
   puts $idrex "$rex_ftype"
   puts $idrex "@FINTYPFIC@"
   puts $idrex "@TEXTE@"
   puts $idrex [$parent.f2.tx get 1.0 end]
   puts $idrex "@FINTEXTE@"
   if { $fich_asso } {
      puts $idrex "@FICASS@"
      puts $idrex "F"
      puts $idrex "@FINFICASS@"
   }
   close $idrex

# prparation de la ligne de commande  excuter
   set lcmd ""
   set argu ""
   set serv $astk::agla(num_serv)
   append lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_creer"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"
   if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
     || $astk::config($serv,login) != $astk::config(-1,login) } {
      append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
   }
   append argu $frex
   # si fichiers associs
   if { $fich_asso } {
      append argu " "
      if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
        || $astk::config($serv,login) != $astk::config(-1,login) } {
         append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
      }
      append argu $fexp
   }
#  execution
   set iret [ ashare::rexec_cmd $serv astk::config $lcmd $argu 0 out $parent]
   if { $iret == 0 } {
      if { [regexp {INDEX[ ]*=[ ]*([0-9]+)} $out mat1 index] } {
         set msg [ashare::mess ihm 226 $index]
         change_status $msg
      } else {
         ashare::mess "erreur" 3 "as_rex_creer" 99 $out
      }
   } else {
      ashare::mess "erreur" 3 "as_rex_creer" $iret $out
      set msg [ashare::mess ihm 60 $iret]
      change_status $msg
      tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info -parent $parent
   }

   # ferme la fenetre d'emission
   destroy $parent
}

# RAZ du filtre
#################################################################
proc rex_ini_filtres { } {
   foreach fil { etat type vers an emet_dpt emet_nom corresp_dpt corresp_nom correct_dpt correct_nom } {
      set astk::rex(filt,$fil) "*"
   }
   set fil "txt"
   set astk::rex(filt,$fil) ""
}

# consultation des fiches
# action = normal, correct ou suppr
#################################################################
proc rex_consult { {action "normal"} } {
   set liste $astk::agla(list_cua)
   set nb [expr [llength $liste] / 4]
   set cua_nom [list]
   set cua_dpt [list]
   for {set j 0} {$j < $nb} {incr j} {
      lappend cua_nom [lindex $liste [expr $j*4]]
      lappend cua_dpt [lindex $liste [expr $j*4 + 3]]
   }

   set fen .fen_rex_consult
   catch {destroy $fen}
   toplevel $fen
   wm withdraw $fen
   wm title $fen "[ashare::mess ihm 11]"

   ##############################
   # f0:filtres, f1:liste, f2:boutons, f3:message+fermer
   pack [frame $fen.f0  -relief flat -bd 0] -fill x -side top -anchor nw
   pack [frame $fen.f0b -relief raised -bd 1] -fill x
   pack [frame $fen.f2  -relief flat -bd 0] -side right -fill y
   pack [frame $fen.f1  -relief flat -bd 0] -fill both -expand yes -padx 5 -pady 5
   pack [frame $fen.f3  -relief flat -bd 0] -fill x -side top -padx 5

   ##############################
   # filtres
   pack [frame $fen.f0.f1 -relief raised -bd 1] -side left -fill y
   rex_filtre $fen.f0.f1 "Etat" astk::rex(filt,etat) {EMIS_UA EMIS_CUA EMIS_* SANS_SUITE ENREGISTRE A_VALIDER VISE_ASA SOLDE} "-side top" "-side top"

   pack [frame $fen.f0.f2 -relief raised -bd 1] -side left -fill y
   rex_filtre $fen.f0.f2 "Type" astk::rex(filt,type) {AL EL ED AO EO A* E* *L *O} "-side top" "-side top"

   pack [frame $fen.f0.f3 -relief raised -bd 1] -side left -fill y
   rex_filtre $fen.f0.f3 "Version" astk::rex(filt,vers) {NEW5 STA5 NEW6 STA6 NEW7 STA7 *5 *6 *7} "-side top" "-side top"

   pack [frame $fen.f0.f4 -relief raised -bd 1] -side left -fill y
      label $fen.f0.f4.lab -font $astk::ihm(font,lab) -text "Emetteur" -anchor w
      pack $fen.f0.f4.lab -side top -padx 3 -fill x
      pack [frame $fen.f0.f4.f1 -relief flat -bd 0] -side top -fill x
      set max1 [rex_filtre $fen.f0.f4.f1 "Dpt" astk::rex(filt,emet_dpt) $astk::rex(list_emet_dpt) \
         "-fill x -side left -anchor w" "-side right -anchor e" \
         {raffr_filtre .fen_rex_consult.f0.f4.f2 emet}]
      pack [frame $fen.f0.f4.f2 -relief flat -bd 0] -side top -fill x
      set max2 [rex_filtre $fen.f0.f4.f2 "Nom" astk::rex(filt,emet_nom) {} "-fill x -side left -anchor w" "-side right -anchor e"]
      if { $max1 > $max2 } {
         $fen.f0.f4.lab configure -width [expr $max1 + 12]
      } else {
         $fen.f0.f4.lab configure -width [expr $max2 + 12]
      }
   set prec $astk::rex(filt,emet_nom)
   raffr_filtre .fen_rex_consult.f0.f4.f2 emet
   if { [lsearch $astk::rex(choix,emet) $prec] > -1 } {
      set astk::rex(filt,emet_nom) $prec
   }

   pack [frame $fen.f0.f5 -relief raised -bd 1] -side left -fill y
      label $fen.f0.f5.lab -font $astk::ihm(font,lab) -text "Correspondant" -anchor w
      pack $fen.f0.f5.lab -side top -padx 3 -fill x
      pack [frame $fen.f0.f5.f1 -relief flat -bd 0] -side top -fill x
      set max1 [rex_filtre $fen.f0.f5.f1 "Dpt" astk::rex(filt,corresp_dpt) $astk::rex(list_corresp_dpt) \
         "-fill x -side left -anchor w" "-side right -anchor e" \
         {raffr_filtre .fen_rex_consult.f0.f5.f2 corresp}]
      pack [frame $fen.f0.f5.f2 -relief flat -bd 0] -side top -fill x
      set max2 [rex_filtre $fen.f0.f5.f2 "Nom" astk::rex(filt,corresp_nom) {} "-fill x -side left -anchor w" "-side right -anchor e"]
      if { $max1 > $max2 } {
         $fen.f0.f5.lab configure -width [expr $max1 + 12]
      } else {
         $fen.f0.f5.lab configure -width [expr $max2 + 12]
      }
   set prec $astk::rex(filt,corresp_nom)
   raffr_filtre .fen_rex_consult.f0.f5.f2 corresp
   if { [lsearch $astk::rex(choix,corresp) $prec] > -1 } {
      set astk::rex(filt,corresp_nom) $prec
   }

   pack [frame $fen.f0.f6 -relief raised -bd 1] -side left -fill y
      label $fen.f0.f6.lab -font $astk::ihm(font,lab) -text "Correcteur" -anchor w
      pack $fen.f0.f6.lab -side top -padx 3 -fill x
      pack [frame $fen.f0.f6.f1 -relief flat -bd 0] -side top -fill x
      set max1 [rex_filtre $fen.f0.f6.f1 "Dpt" astk::rex(filt,correct_dpt) $astk::rex(list_corresp_dpt) \
         "-fill x -side left -anchor w" "-side right -anchor e" \
         {raffr_filtre .fen_rex_consult.f0.f6.f2 correct}]
      pack [frame $fen.f0.f6.f2 -relief flat -bd 0] -side top -fill x
      set max2 [rex_filtre $fen.f0.f6.f2 "Nom" astk::rex(filt,correct_nom) {} "-fill x -side left -anchor w" "-side right -anchor e"]
      if { $max1 > $max2 } {
         $fen.f0.f6.lab configure -width [expr $max1 + 12]
      } else {
         $fen.f0.f6.lab configure -width [expr $max2 + 12]
      }
   set prec $astk::rex(filt,correct_nom)
   raffr_filtre .fen_rex_consult.f0.f6.f2 correct
   if { [lsearch $astk::rex(choix,correct) $prec] > -1 } {
      set astk::rex(filt,correct_nom) $prec
   }

   pack [frame $fen.f0.f7 -relief raised -bd 1] -side left -fill both -expand yes
   set lann [list]
   for {set a [clock format [clock seconds] -format "%Y"]} {$a > 1997} {incr a -1} { lappend lann $a }
   rex_filtre $fen.f0.f7 "Anne" astk::rex(filt,an) $lann "-side top" "-side top"

   ##############################
   # filtre texte
   pack [frame $fen.f0b.f1 -relief flat -bd 0] -side left -pady 5
      label $fen.f0b.f1.lab -font $astk::ihm(font,lab) -text "[ashare::mess ihm 176] :"
      entry $fen.f0b.f1.var -font $astk::ihm(font,val) -textvariable astk::rex(filt,txt) -width 40
      pack $fen.f0b.f1.lab $fen.f0b.f1.var -side left
      bind $fen.f0b.f1.var <Return> "$fen.f2.f1.rech invoke"

   ##############################
   # liste
   listbox $fen.f1.lst -xscrollcommand "$fen.f1.scrollx set" -yscrollcommand "$fen.f1.scrolly set" \
      -selectmode extended -height 20 -width 100 -font $astk::ihm(font,zonfix) -setgrid true -bg white -listvar rex_liste
   scrollbar $fen.f1.scrolly -command "$fen.f1.lst yview"
   scrollbar $fen.f1.scrollx -command "$fen.f1.lst xview" -orient h
   pack $fen.f1.scrolly -side right  -fill y
   pack $fen.f1.scrollx -side bottom -fill x
   pack $fen.f1.lst -expand yes -fill both

   ##############################
   # boutons
   pack [frame $fen.f2.f1 -relief flat -bd 0] -side top -fill x
   pack [frame $fen.f2.f2 -relief flat -bd 0] -side bottom -fill both

   button $fen.f2.f1.rech -font $astk::ihm(font,labbout) -text "Rechercher" -bg $astk::ihm(couleur,rex_chercher) \
      -command "rex_actu_liste $fen"
   button $fen.f2.f1.voir -font $astk::ihm(font,labbout) -text "Visualiser" -bg $astk::ihm(couleur,rex_voir) \
      -command "rex_sel_fiche $fen normal"
   button $fen.f2.f1.print -font $astk::ihm(font,labbout) -text "Imprimer" -bg $astk::ihm(couleur,rex_imprimer) \
      -command "rex_impr_fiche $fen"
   button $fen.f2.f1.fich -font $astk::ihm(font,labbout) -text "Fichiers\nassocis" -bg $astk::ihm(couleur,rex_fich) \
      -command "rex_fich_fiche $fen"
   button $fen.f2.f1.etud -font $astk::ihm(font,labbout) -text "Etude\nassocie" -bg $astk::ihm(couleur,rex_etude) \
      -command "rex_ouvr_etude $fen"
   pack $fen.f2.f1.rech $fen.f2.f1.voir $fen.f2.f1.print $fen.f2.f1.fich $fen.f2.f1.etud \
      -side top -fill x -expand yes -padx 10 -pady 5
# en cas de correction
   if { $action == "correct" } {
      button $fen.f2.f1.rep -font $astk::ihm(font,labbout) -text "Rponse\ndfinitive" -bg $astk::ihm(couleur,rex_reponse) \
         -command "rex_sel_fiche $fen $action"
      pack $fen.f2.f1.rep \
         -side top -fill x -expand yes -padx 10 -pady 5
   }
# suppression de fiche
   if { $action == "suppr" } {
      button $fen.f2.f1.rep -font $astk::ihm(font,labbout) -text [ashare::mess ihm 181] -bg $astk::ihm(couleur,suppr) \
         -command "rex_sel_fiche $fen $action"
      pack $fen.f2.f1.rep \
         -side top -fill x -expand yes -padx 10 -pady 5
   }
   button $fen.f2.f1.prlst -font $astk::ihm(font,labbout) -text "Imprimer\nla liste" -bg $astk::ihm(couleur,rex_imprimer) \
      -command "rex_impr_liste $fen"
   pack $fen.f2.f1.prlst \
      -side top -fill x -expand yes -padx 10 -pady 5

   button $fen.f2.f2.ferm -font $astk::ihm(font,labbout) -text "Fermer" -command "destroy $fen" -bg $astk::ihm(couleur,annul)
   pack $fen.f2.f2.ferm -side bottom -fill x -expand yes -padx 10 -pady 5 -anchor s

   ##############################
   # message+fermer
   label $fen.f3.msg -font $astk::ihm(font,val) -textvariable rex_liste_msg -anchor w -relief sunken
   pack $fen.f3.msg -side left -fill x -expand yes

   ##############################
   # double-clic = visualiser
   bind $fen.f1.lst <Double-Button-1> "$fen.f2.f1.voir invoke"

   wm deiconify $fen
# dsactiver car se maximise immdiatement !?
#    ashare::trace_geom rex $fen
}

# cree un widget filtre complet
#################################################################
proc rex_filtre { w titre variab lch args1 args2 {cmd ""}} {
   label $w.t -font $astk::ihm(font,lab) -text $titre
   set max 0
   set nb [llength $lch]
   set Menu [tk_optionMenu $w.f $variab "*"]
   if { $cmd != "" } {
      $Menu entryconfigure 0 -font $astk::ihm(font,labmenu) -command $cmd
   } else {
      $Menu entryconfigure 0 -font $astk::ihm(font,labmenu)
   }
   for {set j 0} {$j < $nb} {incr j} {
      $Menu add radiobutton
      if { $cmd != "" } {
         $Menu entryconfigure [expr $j+1] -label [lindex $lch $j] -font $astk::ihm(font,labmenu) \
            -variable $variab -command $cmd
      } else {
         $Menu entryconfigure [expr $j+1] -label [lindex $lch $j] -font $astk::ihm(font,labmenu) -variable $variab
      }
      if { $max < [string length [lindex $lch $j]] } {
         set max [string length [lindex $lch $j]]
      }
   }
   if { [regexp -- {-side[ ]+top} $args2] } {
      set max [expr $max + 6]
      $w.t configure -width $max
   }
   eval pack $w.t -padx 3 $args1
   eval pack $w.f -padx 3 $args2
   return $max
}

# raffraichit la liste des noms possibles
#################################################################
proc raffr_filtre { w liste} {
   catch {destroy $w.f}
   #  filtrer
   set v "$liste"
   append v "_dpt"
   set filtre "$astk::rex(filt,$v)"
   # liste des noms
   set v "list_$liste"
   append v "_nom"
   set lch $astk::rex($v)
   set nb [llength $lch]
   set variab "astk::rex(filt,"
   append variab $liste
   append variab "_nom)"
   set $variab "*"
   set Menu [tk_optionMenu $w.f $variab "*"]
   $Menu entryconfigure 0 -font $astk::ihm(font,labmenu)
   set nj 0
   set astk::rex(choix,$liste) [list]
   for {set j 0} {$j < $nb} {incr j} {
      regexp {(.*)/(.*)} [lindex $lch $j] mat1 lab uni
      if { $uni == $filtre } {
         incr nj
         $Menu add radiobutton
         $Menu entryconfigure $nj -label $lab -font $astk::ihm(font,labmenu) -variable $variab
         lappend astk::rex(choix,$liste) $lab
      }
   }
   eval pack $w.f -padx 3 "-side right -anchor e"
}

# actualise la liste des fiches
# parent = fenetre qui contient la liste
# filtres : etat type vers emet_dpt emet_nom corresp_dpt corresp_nom correct_dpt correct_nom an txt
#################################################################
proc rex_actu_liste { parent } {
   global rex_liste
   global rex_liste_msg

   set w $parent.f1.lst
   set rex_liste_msg [ashare::mess ihm 231]

# prparation de la ligne de commande  excuter
   set serv $astk::agla(num_serv)
   set lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_consult"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"

   set ftmp [file join $astk::tmpdir .file_rex_consult]
   file delete -force $ftmp
   set argu "-l "
   if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
     || $astk::config($serv,login) != $astk::config(-1,login) } {
      append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
   }
   append argu $ftmp

# prparation du filtre
   # filtrage tous sauf txt
   set a_filtrer 0
   set fscr [file join $astk::tmpdir .file_rex_filtre]
   foreach fil {an type etat vers emet_dpt emet_nom corresp_dpt corresp_nom correct_dpt correct_nom} {
      if { $astk::rex(filt,$fil) != "*" } {
         if { $a_filtrer == 0 } {
            set a_filtrer 1
            set ids [open $fscr w]
            puts $ids "#!/bin/ksh"
            puts $ids "cat \$1 \\"
         }
         switch $fil {
            etat {
               set ind 12
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            type {
               set ind 3
               regsub -all {\*} $astk::rex(filt,$fil) "" val
               if { [regexp {^\*} $astk::rex(filt,$fil)] } {
                  append val "\$"
               } elseif { [regexp {\*$} $astk::rex(filt,$fil)] } {
                  set val "^$val"
               }
               puts $ids " | awk -F'|' '\$$ind ~ /$val/ \{print \$0\}' \\"
            }
            vers {
               set ind 10
               regsub -all {\*} $astk::rex(filt,$fil) "" val
               if { [regexp {^\*} $astk::rex(filt,$fil)] } {
                  append val "\$"
               } elseif { [regexp {\*$} $astk::rex(filt,$fil)] } {
                  set val "^$val"
               }
               puts $ids " | awk -F'|' '\$$ind ~ /$val/ \{print \$0\}' \\"
            }
            an   {
               set ind 4
               puts $ids " | awk -F'|' '\$$ind ~ /^$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            emet_nom {
               set ind 5
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            emet_dpt {
               set ind 6
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            corresp_nom {
               set ind 8
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            corresp_dpt {
               set ind 9
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            correct_nom {
               set ind 13
               puts $ids " | awk -F'|' '\$$ind ~ /$astk::rex(filt,$fil)/ \{print \$0\}' \\"
            }
            correct_dpt {
               set ind 13
               if { $astk::rex(filt,correct_nom) == "*" } {
                  set fff [join $astk::rex(choix,correct) "|"]
                  puts $ids " | awk -F'|' '\$$ind ~ /$fff/ \{print \$0\}' \\"
               }
            }
         }
      }
   }
   # filtrage txt
   set a_filtrer_txt 0
   if { $astk::rex(filt,txt) != "" } {
      set a_filtrer_txt 1
      set n [clock seconds]
      set fout "$ftmp.out.$n"
      if { $a_filtrer == 0 } {
         set a_filtrer 1
         set ids [open $fscr w]
         puts $ids "#!/bin/ksh"
         puts $ids "cat \$1 \\"
      }
   }
   # fin du script
   if { $a_filtrer } {
      close $ids
      append argu " -s "
      if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
        || $astk::config($serv,login) != $astk::config(-1,login) } {
         append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
      }
      append argu $fscr
   }
   if { $a_filtrer_txt } {
      append argu " -f '$astk::rex(filt,txt)' -o "
      if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
        || $astk::config($serv,login) != $astk::config(-1,login) } {
         append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
      }
      append argu $fout
   }

# execution
   set iret [ ashare::rexec_cmd $serv astk::config $lcmd $argu 0 out $parent]

# traitement de l'output
   if { $iret == 0 } {
      set rex_liste_msg [ashare::mess ihm 232]
      ashare::pointeur off
      set nb 0
      # remplissage du widget
      if [file exist $ftmp] {
         set idf [open $ftmp r]
         $w delete 0 end
         while {![eof $idf]} {
            set line ""
            if { [gets $idf line] > 0 } {
               lappend rex_liste $line
               incr nb
            }
         }
         close $idf
      }
      set rex_liste_msg "$nb fiche"
      if { $nb > 1 } {
         append rex_liste_msg "s"
      }
      if { $a_filtrer_txt } {
         set fen .f_rex_out_$n
         catch {destroy $fen}
         toplevel $fen
         wm title $fen "Filtre : $astk::rex(filt,txt)"
      #  texte
         pack [frame $fen.txt -relief solid -bd 0] -anchor c -fill both -expand yes
         text $fen.txt.tx -xscrollcommand "$fen.txt.scrollx set" -yscrollcommand "$fen.txt.scrolly set" \
            -height 20 -width 80 -font $astk::ihm(font,zonfix) -bg $astk::ihm(couleur,entry_background) -wrap none
         scrollbar $fen.txt.scrolly -command "$fen.txt.tx yview"
         scrollbar $fen.txt.scrollx -command "$fen.txt.tx xview" -orient h
         pack $fen.txt.scrolly -side right  -fill y
         pack $fen.txt.scrollx -side bottom -fill x
         pack $fen.txt.tx -expand yes -fill both
         if { [file exists $fout] } {
            set id [open $fout r]
            $fen.txt.tx insert end [read $id [file size $fout]]
            close $id
            file delete -force $fout
         }
         $fen.txt.tx configure -state disabled
      #  fermer
         button $fen.ok -font $astk::ihm(font,labbout) -text "Ok" \
            -background $astk::ihm(couleur,valid) \
            -command "destroy $fen"
         pack $fen.ok -padx 10 -pady 3 -anchor c
      }
      ashare::pointeur on
   } else {
# code retour de as_rex_consult
      set rex_liste_msg [ashare::mess ihm 60 $iret]
   }
}

# traite les fiches slectionnes
# parent = fenetre qui contient la liste
# action = normal, correct ou suppr
#################################################################
proc rex_sel_fiche { parent action } {
   global rex_liste_msg rex_liste

   set w $parent.f1.lst
   if { [$w curselection] == "" } {
      set rex_liste_msg "<ALARME> Il faut slectionner une fiche."
      bell
   } else {
      set rex_liste_msg [ashare::mess ihm 231]
      ashare::pointeur off
      set indsel [$w curselection]
      set nbsel [llength $indsel]
      for {set i 0} {$i < $nbsel} {incr i} {
         set nsel [lindex $indsel $i]
         set fiche [split [lindex $rex_liste $nsel] "|"]
         regsub -all " " [lindex $fiche 11] "" correcteur
         regsub -all " " $astk::config(-1,nom_user) "\." tmp_user
         if { $action == "correct" &&
            ([regexp "ENREGISTRE" [lindex $fiche 1]] != 1 &&
            ([regexp "A_VALIDER" [lindex $fiche 1]] != 1 || $correcteur != $tmp_user)) } {
            set rex_liste_msg "La fiche n'est pas dans l'tat ENREGISTRE ou A_VALIDER ou vous n'tes pas le CORRECTEUR !"
            bell
            ashare::pointeur on
            return
         } elseif { $action == "suppr" && [regexp "EMIS_" [lindex $fiche 1]] != 1 } {
            set rex_liste_msg "La fiche n'est pas dans l'tat EMIS_UA ou EMIS_CUA !"
            bell
            ashare::pointeur on
            return
         }
         if { $action == "normal" || $action == "correct" } {
            rex_visu_fiche $parent $action $fiche $nsel
         } elseif { $action == "suppr" } {
            rex_suppr_fiche $parent $fiche $nsel
         }
      }
#set rex_liste_msg [ashare::mess ihm 12]
      ashare::pointeur on
   }
}

# visualise une fiche
# parent = fenetre qui contient la liste
# action = normal ou correct
# fiche  = ligne de la fiche qui apparait dans la liste
# nsel   = numro de la ligne correspondante
# fen    = si on doit rutiliser une fenetre existante
#################################################################
proc rex_visu_fiche { parent action fiche nsel {fen ""}} {
# fenetre toujours ouverte
   if { [winfo exists $parent] == 0 } {
      set msg "La fentre contenant la liste a t ferme."
      tk_messageBox -message $msg -type ok -icon info -parent $fen
      return 1
   }
   set w $parent.f1.lst
# numro d'index
   set nch [llength $fiche]
   set nfiche [lindex $fiche [expr $nch - 1]]
# ligne de commande  excuter
   set serv $astk::agla(num_serv)
   set lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_consult"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"
#  execution
   if { $fen == "" } {
      set iret [ashare::rexec_cmd $serv astk::config $lcmd "-n $nfiche" 0 out $parent]
   } else {
      set iret [ashare::rexec_cmd $serv astk::config $lcmd "-n $nfiche" 0 out $fen]
   }
   if { $iret != 0 } {
# code retour de as_rex_consult
      set rex_liste_msg [ashare::mess ihm 60 $iret]
      return $iret
   }
   if { $fen == "" } {
      set n [clock seconds]
      set fen .f_rex_$n
      catch {destroy $fen}
      toplevel $fen
   } else {
      for {set k 0} {$k < 13} {incr k} {
         catch {destroy $fen.f$k}
      }
      catch {destroy $fen.valid}
   }
#  decoder le contenu de la fiche
   # titre
   set nbmc [expr [llength $astk::rex(mcle)] - 1]
   for {set j 0} {$j < $nbmc} {incr j} {
      set mc   [lindex $astk::rex(mcle) $j]
      set suiv [lindex $astk::rex(mcle) [expr $j + 1]]
      # sauf pour le dernier
      if { $suiv != "" } {
         append suiv ":"
      }
      set tfich($mc) ""
      regexp "$mc:(.*)\n$suiv" $out mat1 tfich($mc)
   }
   # mnage dans les champs texte
   foreach mc {Description "Reponse preliminaire" "Reponse definitive"} {
      regsub -all {^<[ \n]*} $tfich($mc) "" tfich($mc)
      regsub -all {[ \n]*>$} $tfich($mc) "" tfich($mc)
      regsub -all {[ ]+\n}   $tfich($mc) "\n" tfich($mc)
   }
   array set astk::rex_fiche [array get tfich]
# affichage de la fiche
   rex_affich_fiche $parent $action $nsel $fen
}

# fentre d'affichage du contenu d'une fiche
# parent = fenetre qui contient la liste
# action = normal ou correct
#################################################################
proc rex_affich_fiche { parent action nsel fen } {
   global rex_liste type_repdef
   array set tfich [array get astk::rex_fiche]
   set w $parent.f1.lst
   # titre de la fentre
   if { $fen != "" } {
      set fiche [split [lindex $rex_liste $nsel] "|"]
   # titre de la fiche
      set ref "Fiche "
      append ref [lindex $fiche 2]
      append ref " "
      append ref [lindex $fiche 3]
      if { [regexp -- {-\?\?\?} $ref] } {
         append ref " ([lindex $fiche 15])"
      }
      wm title $fen $ref
   }

   ##############################
   pack [frame $fen.f0  -relief flat -bd 0] -fill x -anchor nw
   pack [frame $fen.f1  -relief flat -bd 0] -fill x
   pack [frame $fen.f2  -relief flat -bd 0] -fill x
   pack [frame $fen.f3  -relief flat -bd 0] -fill x
   pack [frame $fen.f4  -relief flat -bd 0] -fill x
   pack [frame $fen.f5  -relief flat -bd 0] -fill x
   pack [frame $fen.f6  -relief flat -bd 0] -fill x
   pack [frame $fen.f7  -relief flat -bd 0] -fill x
   pack [frame $fen.f8  -relief flat -bd 0] -fill x
   pack [frame $fen.f9  -relief flat -bd 0] -fill x
   pack [frame $fen.f10 -relief flat -bd 0] -fill both -expand yes
   pack [frame $fen.f11 -relief flat -bd 0] -fill x
   pack [frame $fen.f12 -relief flat -bd 0] -fill x

   ##############################
   # entete
   set lab "Titre : $tfich(Titre)"
   label $fen.f0.tit -font $astk::ihm(font,lab) -text $lab -anchor w
   set lab "Version : $tfich(Version emission)"
   label $fen.f0.ver -font $astk::ihm(font,lab) -text $lab
   pack $fen.f0.ver -padx 5 -side right
   pack $fen.f0.tit -padx 5 -side left -fill x -expand yes
   #
   set lab "Rdacteur : $tfich(Redacteur)"
   label $fen.f1.red -font $astk::ihm(font,lab) -text $lab -width 35 -anchor w
   set lab "Dpartement : $tfich(Departement Redacteur)"
   label $fen.f1.dpt -font $astk::ihm(font,lab) -text $lab -width 30 -anchor w
   set lab "Date : $tfich(Date Redaction)"
   label $fen.f1.dat -font $astk::ihm(font,lab) -text $lab -width 15 -anchor w
   pack $fen.f1.red $fen.f1.dpt $fen.f1.dat -padx 5 -side left
   #
   set lab "Correspondant : $tfich(Correspondant)"
   label $fen.f2.red -font $astk::ihm(font,lab) -text $lab -width 35 -anchor w
   set lab "Dpartement : $tfich(Departement Correspondant)"
   label $fen.f2.dpt -font $astk::ihm(font,lab) -text $lab -width 30 -anchor w
   set lab "Date : $tfich(Date transmission)"
   label $fen.f2.dat -font $astk::ihm(font,lab) -text $lab -width 15 -anchor w
   pack $fen.f2.red $fen.f2.dpt $fen.f2.dat -padx 5 -side left
   #
   set lab "Commande : $tfich(Concerne)"
   label $fen.f3.com -font $astk::ihm(font,lab) -text $lab -anchor w
   pack $fen.f3.com -padx 5 -side left -fill x -expand yes
   #
   ##############################
   set lab "Description :"
   label $fen.f4.lbl -font $astk::ihm(font,lab) -text $lab -anchor w
   pack $fen.f4.lbl -padx 5 -fill x
   # texte
   pack [frame $fen.f4.tx -relief solid -bd 0] -anchor c -fill x -expand yes
   text $fen.f4.tx.tx -yscrollcommand "$fen.f4.tx.scrolly set" \
      -height 10 -font $astk::ihm(font,zonfix) -bg $astk::ihm(couleur,entry_background) -wrap word
   scrollbar $fen.f4.tx.scrolly -command "$fen.f4.tx.tx yview"
   pack $fen.f4.tx.scrolly -side right -fill y
   pack $fen.f4.tx.tx -expand yes -fill both -expand yes
   # remplissage du texte
   $fen.f4.tx.tx insert end $tfich(Description)
   $fen.f4.tx.tx configure -state disabled
   #
   set lab "Gravit : $tfich(Gravite)"
   label $fen.f5.gra -font $astk::ihm(font,lab) -text $lab -width 35 -anchor w
   set lab "A raliser pour : $tfich(Date de realisation negociee)"
   label $fen.f5.del -font $astk::ihm(font,lab) -text $lab -width 35 -anchor e
   pack $fen.f5.del -padx 5 -side right
   pack $fen.f5.gra -padx 5 -side left -fill x
   #
   ##############################
   set lab "Rponse prliminaire :"
   label $fen.f6.lbl -font $astk::ihm(font,lab) -text $lab -anchor w
   set lab "Date : $tfich(Date presentation EDA)"
   label $fen.f6.dat -font $astk::ihm(font,lab) -text $lab
   pack $fen.f6.dat -padx 5 -side right
   pack $fen.f6.lbl -padx 5 -fill x
   # texte
   pack [frame $fen.f7.tx -relief solid -bd 0] -anchor c -fill x -expand yes
   text $fen.f7.tx.tx -yscrollcommand "$fen.f7.tx.scrolly set" \
      -height 10 -font $astk::ihm(font,zonfix) -bg $astk::ihm(couleur,entry_background) -wrap word
   scrollbar $fen.f7.tx.scrolly -command "$fen.f7.tx.tx yview"
   pack $fen.f7.tx.scrolly -side right -fill y
   pack $fen.f7.tx.tx -expand yes -fill both -expand yes
   # remplissage du texte
   $fen.f7.tx.tx insert end $tfich(Reponse preliminaire)
   $fen.f7.tx.tx configure -state disabled
   #
   set lab "Correcteur : $tfich(Correcteur)"
   label $fen.f8.cor -font $astk::ihm(font,lab) -text $lab -width 35 -anchor w
   set lab "Rponse : $tfich(Type de reponse definitive)"
   label $fen.f8.rep -font $astk::ihm(font,lab) -text $lab -width 35 -anchor e
   pack $fen.f8.rep -padx 5 -side right
   pack $fen.f8.cor -padx 5 -side left -fill x
   #
   ##############################
   set lab "Rponse dfinitive :"
   label $fen.f9.lbl -font $astk::ihm(font,lab) -text $lab -anchor w
   if { $action == "normal" } {
      set lab "Date : $tfich(Date correction)"
      label $fen.f9.dat -font $astk::ihm(font,lab) -text $lab
      pack $fen.f9.dat -padx 5 -side right
   } else {
      label $fen.f9.dat -font $astk::ihm(font,lab) -text "Rponse : "
      set bid_repdef 0
      set type_repdef fait
      set MenuRep [tk_optionMenu $fen.f9.lst bid_repdef "Corrig/Ralis"]
      $MenuRep entryconfigure 0 -font $astk::ihm(font,labmenu) -command "set type_repdef fait"
      $MenuRep add radiobutton
      $MenuRep entryconfigure 1 -label "Sans suite" -font $astk::ihm(font,labmenu) -variable bid_repdef -command "set type_repdef sans_suite"
      pack $fen.f9.lst -padx 5 -side right
      pack $fen.f9.dat -padx 5 -side right
   }
   pack $fen.f9.lbl -padx 5 -fill x
   # texte
   pack [frame $fen.f10.tx -relief solid -bd 0] -anchor c -fill both -expand yes
   text $fen.f10.tx.tx -yscrollcommand "$fen.f10.tx.scrolly set" \
      -height 10 -font $astk::ihm(font,zonfix) -bg $astk::ihm(couleur,entry_background) -wrap word
   scrollbar $fen.f10.tx.scrolly -command "$fen.f10.tx.tx yview"
   pack $fen.f10.tx.scrolly -side right -fill y
   pack $fen.f10.tx.tx -expand yes -fill both -expand yes
   # remplissage du texte
   $fen.f10.tx.tx insert end $tfich(Reponse definitive)
   if { $action == "normal" } {
      $fen.f10.tx.tx configure -state disabled
   }
   #
   set lab "Date de prsentation  l'EDA : $tfich(Date correction)"
   label $fen.f11.cor -font $astk::ihm(font,lab) -text $lab
   pack $fen.f11.cor -padx 5 -fill x
   #
   set lab "Version Aster de ralisation : $tfich(Version correction)"
   label $fen.f12.ver -font $astk::ihm(font,lab) -text $lab -width 35 -anchor w
   set lab "Date : $tfich(Date correction effective)"
   label $fen.f12.dat -font $astk::ihm(font,lab) -text $lab -width 35 -anchor e
   pack $fen.f12.dat -padx 5 -side right
   pack $fen.f12.ver -padx 5 -side left -fill x

   # fermer
   pack [frame $fen.valid -relief solid -bd 0] -fill x
      pack [frame $fen.valid.g -relief solid -bd 0] -side left
      pack [frame $fen.valid.d -relief solid -bd 0] -side right
      pack [frame $fen.valid.c -relief solid -bd 0] -fill x

   if { $action == "normal" } {
   # OK
      button $fen.valid.c.ok -font $astk::ihm(font,labbout) -text "Ok" \
         -background $astk::ihm(couleur,valid) \
         -command "destroy $fen"
      pack $fen.valid.c.ok -padx 10 -pady 3

   # bouton prcdente/suivante
      set m1 [expr $nsel - 1]
      if { $m1 < 0 } {
         set m1 0
      }
      set p1 [expr $nsel + 1]
      set ms1 [expr [$w size] - 1]
      if { $p1 > $ms1 } {
         set p1 $ms1
      }
      button $fen.valid.g.b -font $astk::ihm(font,labbout) -text "< Prcdente" -command "rex_visu_fiche $parent $action {[split [lindex $rex_liste $m1] |]} $m1 $fen"
      pack $fen.valid.g.b -padx 10 -pady 3
      button $fen.valid.d.b -font $astk::ihm(font,labbout) -text "Suivante >" -command "rex_visu_fiche $parent $action {[split [lindex $rex_liste $p1] |]} $p1 $fen"
      pack $fen.valid.d.b -padx 10 -pady 3
   } else {
   # Rpondre ou annuler
      button $fen.valid.g.b -font $astk::ihm(font,labbout) -text "Enregistrer la rponse" -command "rex_reponse_fiche $fen $fen.f10.tx.tx"
      pack $fen.valid.g.b -padx 10 -pady 3
      button $fen.valid.d.b -font $astk::ihm(font,labbout) -text "Annuler" -command "destroy $fen"
      pack $fen.valid.d.b -padx 10 -pady 3
   }
}

# supprime une fiche
# parent = fenetre qui contient la liste
# fiche  = ligne de la fiche qui apparait dans la liste
# nsel   = numro de la ligne correspondante
#################################################################
proc rex_suppr_fiche { parent fiche nsel } {
   global rex_liste_msg
   set w $parent.f1.lst
# numro d'index
   set nch [llength $fiche]
   set nfiche [lindex $fiche [expr $nch - 1]]
   set etatfiche [lindex $fiche 1]
   regsub -all " " [lindex $fiche 4] "" emet
   regsub -all " " $astk::config(-1,nom_user) "\." tmp_user
# vrifier qu'on a le droit de supprimer cette fiche
   set stop 1
   if { [regexp "^EMIS_" $etatfiche] &&
        ([regexp GRAA $astk::agla(instance)] ||
         ($emet == $tmp_user && 
            ([regexp "EMIS_UA" $etatfiche] ||
            ([regexp "EMIS_CUA" $etatfiche] &&
               ([regexp EDA $astk::agla(instance)] || [regexp CUA $astk::agla(instance)])
            )))) } {
      set stop 0
   }
   if { $stop } {
      set rex_liste_msg [ashare::mess ihm 273]
      return 1
   }
# ligne de commande  excuter
   set serv $astk::agla(num_serv)
   set lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_suppr"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"
#  execution
    set iret [ashare::rexec_cmd $serv astk::config $lcmd $nfiche 0 out $parent]
   if { $iret != 0 } {
# code retour de as_rex_suppr
      set rex_liste_msg [ashare::mess ihm 60 $iret]
      return $iret
   }
# mise  jour de la liste
   $w delete $nsel
   set rex_liste_msg [ashare::mess ihm 274 $nfiche]
}

# fichiers associs dans /aster/rex/anomalie2000/emise/ + numro d'index
#################################################################
proc rex_fich_fiche { parent } {
   global rex_liste_msg rex_liste
   set w $parent.f1.lst
   # chemin en dur ici
   set rep_emise "/aster/rex/anomalie2000/emise"

   if { [$w curselection] == "" } {
      set rex_liste_msg "<ALARME> Il faut slectionner une fiche."
      bell
   } else {
      set rex_liste_msg [ashare::mess ihm 231]
      ashare::pointeur off
      set serv $astk::agla(num_serv)
      set indsel [$w curselection]
      for {set i 0} {$i < [llength $indsel]} {incr i} {
         set nsel [lindex $indsel $i]
         set fiche [split [lindex $rex_liste $nsel] "|"]
         set nch [llength $fiche]
         set nfiche [lindex $fiche [expr $nch - 1]]
         if { [lindex $fiche 0] == "F" } {
         # lancement de la bsf
            set cmd [file join $ashare::root bin bsf]
            set args "--inidir "
            append args [file join $rep_emise $nfiche]
            append args " --inisrv "
            append args $astk::agla(num_serv)
            ashare::rexec_cmd -1 astk::config $cmd $args 1 $parent
         } else {
            set msg "Pas de fichier associ  la fiche $nfiche."
            tk_messageBox -message $msg -type ok -icon info -parent $parent
         }
      }
      set rex_liste_msg [ashare::mess ihm 12]
      ashare::pointeur on
   }
}

# impression de la liste des fiches
#################################################################
proc rex_impr_liste { parent } {
   global rex_liste
   global rex_liste_msg
   set nbf [llength $rex_liste]
   if { $nbf > 0 } {
      set lfich $astk::sel(filename)
      set ftmp [file join $astk::tmpdir .file_rex_list]
      set id [open $ftmp w]
      for {set i 0} {$i < $nbf} {incr i} {
         set fiche [split [lindex $rex_liste $i] "|"]
         set cham { 1 2 3  4  6  8 11 12 13}
         set larg {10 2 8 16 10 50 16 10  6}
         set nch [llength $cham]
         set str ""
         for {set j 0} {$j < $nch} {incr j} {
            set fmt "%"
            append fmt [lindex $larg $j]
            append fmt "s"
            set ch [lindex $fiche [lindex $cham $j]]
            if { [string length $ch] > [lindex $larg $j] } {
               set ch [string range $ch 0 [expr [lindex $larg $j] - 1]]
            }
            if { $j > 0 } {
               append str "|"
            }
            append str [format $fmt $ch]
         }
         puts $id $str
      }
      close $id
   # impression
      set astk::sel(filename) $ftmp
      set astk::sel(servname) $astk::local_server
      ashare::file_print_to $parent
   }
}

# imprime les fiches slectionnes
# parent = fenetre qui contient la liste
#################################################################
proc rex_impr_fiche { parent } {
   global rex_liste_msg rex_liste

   set w $parent.f1.lst
   if { [$w curselection] == "" } {
      set rex_liste_msg "<ALARME> Il faut slectionner une fiche."
      bell
   } else {
      set rex_liste_msg [ashare::mess ihm 231]
      ashare::pointeur off
      set indsel [$w curselection]
      set nbsel [llength $indsel]
      for {set i 0} {$i < $nbsel} {incr i} {
         set nsel [lindex $indsel $i]
         set fiche [split [lindex $rex_liste $nsel] "|"]
         set iret [rex_impr_une_fiche $i $parent $fiche $nsel]
         if { $iret != 0 } {
            break
         }
      }
      set rex_liste_msg [ashare::mess ihm 12]
      ashare::pointeur on
   }
}

# imprime une fiche
# num_fiche = numro de la fiche  imprimer (si plusieurs d'un coup)
# parent = fenetre qui contient la liste
# fiche  = ligne de la fiche qui apparait dans la liste
# nsel   = numro de la ligne correspondante
#################################################################
proc rex_impr_une_fiche { num_fiche parent fiche nsel {fen ""}} {
   global select_printer
# numro d'index
   set nfiche [lindex $fiche 15]
   set etatfiche [lindex $fiche 1]
# ligne de commande  excuter
   set serv $astk::agla(num_serv)
   set lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_consult"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"
#  execution
   if { $fen == "" } {
      set iret [ashare::rexec_cmd $serv astk::config $lcmd "-n $nfiche" 0 out $parent]
   } else {
      set iret [ashare::rexec_cmd $serv astk::config $lcmd "-n $nfiche" 0 out $fen]
   }
   if { $iret != 0 } {
# code retour de as_rex_consult
      set rex_liste_msg [ashare::mess ihm 60 $iret]
      return $iret
   }
#  decoder le contenu de la fiche
   # titre
   set nbmc [expr [llength $astk::rex(mcle)] - 1]
   for {set j 0} {$j < $nbmc} {incr j} {
      set mc   [lindex $astk::rex(mcle) $j]
      set suiv [lindex $astk::rex(mcle) [expr $j + 1]]
      # sauf pour le dernier
      if { $suiv != "" } {
         append suiv ":"
      }
      set tfich($mc) ""
      regexp "$mc:(.*)\n$suiv" $out mat1 tfich($mc)
   }
   # mnage dans les champs texte
   foreach mc {Description "Reponse preliminaire" "Reponse definitive"} {
      regsub -all {^<[ \n]*} $tfich($mc) "" tfich($mc)
      regsub -all {[ \n]*>$} $tfich($mc) "" tfich($mc)
      regsub -all {[ ]+\n}   $tfich($mc) "\n" tfich($mc)
   }
# construction du fichier
   set ftmp [file join $astk::tmpdir .file_rex_impr]
   set id [open $ftmp w]
   # separateur
   set sepa1 "_________________________________________________________________________________\n"
   set sepa2 "=================================================================================\n"
   # titre
   set mc "Numero anomalie"
   puts $id [format "Code_Aster              %48s %-5s" $tfich(Type) $tfich($mc)]
   puts $id $sepa2
   set mc "Version emission"
   puts $id [format "Numero de version : %s" $tfich($mc)]
   puts $id $sepa1
   #
   puts $id [format "Numero de gestion de la fiche : %s" $nfiche]
   set mc "Stade de traitement"
   set mc1 "Presence fichiers associes"
   puts $id [format "Stade d'avancement : %-30s Fichiers associes : %s" $etatfiche $tfich($mc1)]
   set mc "Redacteur"
   set mc1 "Departement Redacteur"
   set mc2 "Date Redaction"
   puts $id [format "Redacteur    :%-20s  Departement : %-13s Date : %s" $tfich($mc) $tfich($mc1) $tfich($mc2)]
   set mc "Correspondant"
   set mc1 "Departement Correspondant"
   set mc2 "Date transmission"
   puts $id [format "Correspondant:%-20s  Departement : %-13s Date : %s" $tfich($mc) $tfich($mc1) $tfich($mc2)]
   puts $id $sepa1
   set mc "Concerne"
   puts $id [format "Commande(s) concerne(s)/Titre : %s" $tfich($mc)]
   if { [regexp {^E} $tfich(Type)] } {
      set mc "Type d'evolution"
      puts $id [format "Type d'evolution logiciel : %s" $tfich($mc)]
   }
   set mc "Delai souhaite"
   puts $id [format "Delai souhaite : %s" $tfich($mc)]
   set mc "Description"
   puts $id [format "Description :\n%s\n" $tfich($mc)]
   puts $id $sepa2
   set mc "Titre"
   puts $id [format "Titre : %s" $tfich($mc)]
   set mc "Date presentation EDA"
   puts $id [format "%80s" [format "Date presentation a l'Equipe De Developpement : %8s" $tfich($mc)]]
   puts $id $sepa1
   set mc "Reponse preliminaire"
   puts $id [format "Reponse preliminaire :\n%s\n" $tfich($mc)]
   set mc "Correcteur"
   puts $id [format "Realisateur designe  : %-20s" $tfich($mc)]
   set mc "Gravite"
   puts $id [format "Gravite : %s" $tfich($mc)]
   puts $id $sepa1
   set mc "Reponse definitive"
   set mc1 "Type de reponse definitive"
   puts $id [format "Reponse definitive   : %s\n\n%s\n" $tfich($mc1) $tfich($mc)]
   set mc "Date correction"
   puts $id [format "%80s" [format "Date realisation : %8s" $tfich($mc)]]
   if { $tfich(Type) != "ED" } {
      set mc "Date presentation correction EDA"
      puts $id [format "%80s" [format "Date de presentation de la realisation a l'Equipe De Developpement : %8s" $tfich($mc)]]
   }
   set mc "Version correction"
   set mc1 "Date correction effective"
   puts $id [format "%80s" [format "Version contenant la modification : %s            Date : %8s" $tfich($mc) $tfich($mc1)]]
   if { [regexp {^E} $tfich(Type)] } {
      set mc "Date visa CPA"
      puts $id [format "%80s" [format "Date visa Chef de Projet Aster : %8s" $tfich($mc)]]
   }
   puts $id $sepa1
   puts $id [format "(C) EDF-R&D 1991-%s" [clock format [clock seconds] -format "%Y"]]
# fermeture
   close $id
# impression
   set astk::sel(filename) $ftmp
   set astk::sel(servname) $astk::local_server
   if { $num_fiche == 0 } {
      set iret [ashare::file_print_to $parent]
   } else {
      set iret 0
      ashare::file_pre-print .fen_bidon $parent
   }
   return $iret
}

# enregistre la rponse  une fiche
# parent = fenetre de la fiche
# w = widget de la zone de texte rponse
#################################################################
proc rex_reponse_fiche { parent w } {
   global type_repdef

   array set tfich [array get astk::rex_fiche]
# numro d'index
   set nfiche $tfich(Numero de gestion)
# correcteur
   set mc "Correcteur"
   set correcteur [agla_cua_get $astk::config(-1,cua) 0]
   set tfich($mc) $correcteur
# date correction
   set mc "Date correction"
   set tfich($mc) [clock format [clock seconds] -format "%d/%m/%Y"]
# rponse dfinitive
   set mc "Reponse definitive"
   set tfich($mc) "<\n"
   append tfich($mc) [$w get 1.0 end]
   append tfich($mc) "\n>"
# type de reponse
   set mc "Type de reponse definitive"
   if { $type_repdef == "fait" } {
      if { [regexp {^A} $tfich(Type)] } {
         set tfich($mc) "CORRIGE"
      } else {
         set tfich($mc) "REALISE"
      }
   } else {
      set tfich($mc) "SANS_SUITE"
   }
# etat
   set mc "Stade de traitement"
   set etat_new "A_VALIDER"
   set tfich($mc) $etat_new
# ajouter les <> dans les champs texte
   foreach mc {Description "Reponse preliminaire"} {
      set tfich($mc) "<\n$tfich($mc)\n>"
   }
#  contenu de la fiche
   set ftmp [file join $astk::tmpdir .ficRA]
   file delete -force $ftmp
   set idfic [open $ftmp w]

   set nbmc [expr [llength $astk::rex(mcle)] - 1]
   for {set j 0} {$j < $nbmc} {incr j} {
      set mc   [lindex $astk::rex(mcle) $j]
      puts $idfic "$mc:$tfich($mc)"
   }
   close $idfic

# appel de as_rex_modfic
# prparation de la ligne de commande  excuter
   set serv $astk::agla(num_serv)
   set lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_rex_modfic"
   append lcmd " --remote_shell_protocol $astk::config(-1,remote_shell_protocol)"
   append lcmd " --remote_copy_protocol $astk::config(-1,remote_copy_protocol)"

   set argu "rep "
   if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config(-1,nom_complet)] != 1
     || $astk::config($serv,login) != $astk::config(-1,login) } {
      append argu "$astk::config(-1,login)@$astk::config(-1,nom_complet):"
   }
   append argu "$ftmp $nfiche $etat_new $correcteur"

# execution
   set iret [ ashare::rexec_cmd $serv astk::config $lcmd $argu 0 out $parent]
   if { $iret != 0 } {
      ashare::mess "erreur" 3 "as_rex_modfic" $iret $out
      set msg [ashare::mess ihm 60 $iret]
      change_status $msg
      tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info -parent $parent
   }

   destroy $parent
}

# raction  "ouvrir etude associe"
#################################################################
proc rex_ouvr_etude { parent } {
   global rex_liste_msg rex_liste
   set w $parent.f1.lst
   # chemin en dur ici
   set rep_emise "/aster/rex/anomalie2000/emise"

   if { [$w curselection] == "" } {
      set rex_liste_msg "<ALARME> Il faut slectionner une fiche."
      bell
   } else {
      set rex_liste_msg [ashare::mess ihm 231]
      ashare::pointeur off
      set serv $astk::agla(num_serv)
      set indsel [$w curselection]
      for {set i 0} {$i < [llength $indsel]} {incr i} {
         set nsel [lindex $indsel $i]
         set fiche [split [lindex $rex_liste $nsel] "|"]
         set nch [llength $fiche]
         set nfiche [lindex $fiche [expr $nch - 1]]
         if { [lindex $fiche 0] == "F" } {
         # le .export existe-t-il ?
            set valf [file join $rep_emise $nfiche $nfiche.export]
            set iret [import_from astk_serv $serv $valf]
            if { $iret == 0 || $iret == 2 } {
               #destroy $fen
            } else {
               set msg "Le fichier export n'existe pas (normal si la fiche a t mise avant astk 1.0.18)."
               tk_messageBox -message $msg -type ok -icon info -parent $parent
            }
         } else {
            set msg "Pas de fichier associ  la fiche $nfiche."
            tk_messageBox -message $msg -type ok -icon info -parent $parent
         }
      }
      set rex_liste_msg [ashare::mess ihm 12]
      ashare::pointeur on
   }
}
